# f411-pulse-recorder

Проект создан для записи длительности импульсов цифровых сигналов на микроконтроллере `STM32F411CEU6`.

# Hardware

## MCU Pinout
![MCU Pinout](images/pinout.png)

## MCU Clocks
![MCU Clocks](images/clocks.png)

# Software

Для работы ПО на компьютере необходимо установить `python3`, создать `venv` и установить все библиотеки, что описаны в `common/requirements.txt`.
Далее просто запустить `common/main.py`. Интерфейс там интуитивно понятный.

Для имитации PWM и бенчмаркинга используется второй микроконтроллер - RP2040. На нем запускается программа `common/rp2040-pwm-generator.py`.
Для проверки работоспособности выставляется эталонная частота и эталонная длительность импульса.
Для проверки максимальной скорости работы устанавливается максимально возможная частота PWM и длительность импульса.

# Benchmarking

... результаты ...

